package com.cool.hot100.dp;

import org.junit.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 *
 * @Author: Cool
 * @Date: 2024/09/24/16:58
 * DayNumber 2
 * Hard 2
 * Level ?
 */
public class Num279 {

    private static final int[][] memory = new int[101][10001];
//
//    static {
//        for (int[] row : memory) {
//            Arrays.fill(row, -1); // -1 表示没有计算过
//        }
//    }

    static {
        for (int[] row : memory) {
            Arrays.fill(row, Integer.MAX_VALUE); // -1 表示没有计算过
        }
        memory[0][0] = 0;
    }

    public int numSquares(int n) {
        for (int i = 1; i * i <= n; i++) {
            for (int j = 0; j <= n; j++) {
                if (j < i * i) {
                    memory[i][j] = memory[i - 1][j];
                } else {
                    memory[i][j] = Math.min(memory[i - 1][j], memory[i][j - i * i] + 1);
                }

            }
        }
        return memory[(int) Math.sqrt(n)][n];
    }


    public int numSquares1(int n) {
        return dfs((int) Math.sqrt(n), n);
    }

    // i是指j比哪些i的平方大，j为当前数字
    private int dfs(int i, int j) {
        if (i == 0) {
            return j == 0 ? 0 : Integer.MAX_VALUE;
        }
        if (memory[i][j] != -1) {
            return memory[i][j];
        }
        if (i * i > j) {
            return memory[i][j] = dfs(i - 1, j);
        }
        return memory[i][j] = Math.min(dfs(i - 1, j), dfs(i, j - i * i) + 1);
    }

    /**
     *
     * 可以类比成为完全背包的零钱问题，把n之前的平方数当作一个个硬币，n是当前有的零钱，则可套用一样的逻辑
     * @param n
     * @return
     */
    public int numSquares2(int n) {
        int[] dp = new int[n + 1];
        // 初始化 dp 数组
        Arrays.fill(dp, Integer.MAX_VALUE);
        dp[0] = 0;
        for (int i = 1; i * i <= n; i++) {
            for (int j = i * i; j <= n; j++) {
                dp[j] = Math.min(dp[j], dp[j - i * i] + 1);
            }
        }
        return dp[n];
    }


}
